<!-- eslint-disable vue/multi-word-component-names -->
<template>
  <b-container class="d-flex flex-column align-items-center">
    <div class="text-box">
      <h1>About the ANTARES Pipeline</h1>
      <p>
        ANTARES processes alerts using a multi-stage pipeline. The pipeline consists of both
        internal ANTARES modules and user-submitted filters. Filters can be thought of as plugins
        for ANTARES which allow researchers to run their own computational logic in ANTARES. This
        page documents the structure of the pipeline and includes the source code of the filters
        which are currently running.
      </p>
      <hr>
    </div>
    <div class="text-box">
      <h2>Inputs</h2>
      <p>
        Currently, ANTARES receives alerts from the ZTF survey in real-time. In the future it will
        process data from additional sources, like LIGO. Its ultimate purpose is to serve as a
        real-time alert broker for LSST.
      </p>
      <hr>
    </div>
    <div class="text-box">
      <h2>Level 1 Filters</h2>
      <p>
        Every alert that ANTARES receives is sent through Level 1 (L1) filters. L1 filters exist to
        slim down the immense input data stream by finding alerts that are likely bogus or that were
        collected in poor conditions.
      </p>
    </div>
    <div class="text-box">
      <hr>
      <h2>Ingestion and Aggregation</h2>
      <p>
        Alerts are ingested and stored in the ANTARES alert database. We also ingest the history
        of past measurements, if such is included in the alert.
      </p>
      <p>
        In cases where the alert is associated with a stellar object in the reference frame and
        likely to be a variable star, we provide corrected magnitude by summing up fluxes from both
        the reference frame and the differential flux from the alert. In case of non-detection in
        the alert history, we use the reference frame flux plus/minus 1-sigma from the ZTF upper
        limit to provide upper/lower limits of the magnitudes.
      </p>
      <p>
        After ingestion we associate each measurement with a known locus of past alerts within 1",
        and with any nearby objects in our catalogs. The catalog search radius is dependent on the
        specific catalog.
      </p>
      <hr>
    </div>
    <div class="text-box">
      <h2>Level 2 Filters</h2>
      <p>
        After alerts are ingested, aggregated, and associated with catalogs, ANTARES runs the L2
        filters. The purpose of the L2 filters is to detect the interesting science alerts based on
        custom criteria.
      </p>
    </div>
    <div v-if="filters">
      <filter-card
        v-for="filter in filters"
        :key="filter.id"
        :filter="filter"
        class="filter-card"
      />
    </div>
    <div class="text-box">
      <hr>
      <h2>Output</h2>
      <p>
        When an alert exits the pipeline it has been flagged with catalog matches, arbitrary new
        data properties generated by the filters, and stream associations. At this point we check
        alerts for association with user-submitted watched objects, and send Slack notifications
        accordingly.
      </p>
      <p>
        Finally, we output the alert to Kafka streams if it was associated with a stream. Downstream
        systems and users connect to the streams in real-time using the ANTARES client library.
      </p>
    </div>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';

import { Filter } from '@/common/types';
import { FilterService } from '@/api';
import FilterCard from '@/components/FilterCard.vue';

export default Vue.extend({
  components: {
    FilterCard,
  },

  data() {
    return {
      filters: [] as Filter[],
    };
  },

  mounted() {
    this.fetchFilters();
  },

  methods: {
    async fetchFilters() {
      const { data: filters } = await FilterService.list({ page: { limit: 100, offset: 0 } });
      // Buffalo buffalo Buffalo buffalo blah blah
      this.filters = filters.filter((filter) => filter.enabled);
    },
  },
});
</script>

<style scoped>
.container {
  max-width: 1000px;
}
.filter-card {
  width: 700px;
  margin-bottom: 0.5em;
}
</style>
